local screenFader = {}

screenFader.fadeSpeed = 0
screenFader.fadeLevel = 0



function screenFader:update(dt)
  self:checkCallbacks()
  self.fadeLevel = self.fadeLevel + dt * self.fadeSpeed
  self.fadeLevel = math.min(math.max(self.fadeLevel, 0), 1)
end


function screenFader:checkCallbacks()
  
  
  if self.fadeLevel == 0 and self.fadeInCallback then 
    self:fadeInCallback()
    self.fadeInCallback = nil
  end
  
  if self.fadeLevel == 1 and self.fadeOutCallback then 
    self:fadeOutCallback()
    self.fadeOutCallback = nil
  end
  
end


function screenFader:setFade(level, speed)
  self.fadeSpeed = speed or 0
  self.fadeLevel = level
end



function screenFader:draw()
  if self.fadeLevel > 0 then
    love.graphics.setColor(0, 0, 0, self.fadeLevel)
    love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
  end
end


function screenFader:doFade(startLevel, speed)
  self.fadeLevel = startLevel
  self.fadeSpeed = speed
end


function screenFader:fadeOut(speed, callback, useCurrentLevel)
  
  local level = 0
  
  useCurrentLevel = useCurrentLevel or true
  
  if useCurrentLevel ~= false then
    level = self.fadeLevel
  end
  
  self:doFade(level, speed or 1)
  self.fadeOutCallback = callback
end


function screenFader:fadeIn(speed, callback, useCurrentLevel)
  
  local level = 1
  
  useCurrentLevel = useCurrentLevel == true or useCurrentLevel == true == nil
  
  if useCurrentLevel then
    level = self.fadeLevel
  end
  
  self:doFade(level, -speed or -1)
  self.fadeInCallback = callback
end


return screenFader