CloudSheet = Entity:extend()
CloudSheet.type = "cloudSheet"

function CloudSheet:new(x, y, z)
  CloudSheet.super.new(self, x, y)
  self.z = z
  
  self.activeStage = nil
  if z == 0 then
    print("WARNING - Z WAS 0. SETTING TO 1")
    self.z = 1
  end
  
  local scale = 5
  
  self.quad = love.graphics.newQuad( -x, -y, window.width, window.height, texture.cloudSheet:getWidth()*camera:getFinalZoom()*scale, texture.cloudSheet:getHeight()*camera.zoom*scale )
  
  texture.cloudSheet:setWrap("repeat", "repeat")

  
end

function CloudSheet:update(dt)
  self.x = self.x + 50*dt
end

local passes = require "rendering"
function CloudSheet:draw()
  
  local x = self.x
  local y = self.y
  
  x = ((x - camera.x)*camera:getFinalZoom())/self.z + window.width/2
  y = ((y - camera.y)*camera:getFinalZoom())/self.z + window.height/2
  
  local scale = 64*100/texture.cloudSheet:getWidth()
  
  
  
  self.quad:setViewport(-x, -y, window.width, window.height, texture.cloudSheet:getWidth()*camera:getFinalZoom()*scale, texture.cloudSheet:getHeight()*camera:getFinalZoom()*scale )
  


  love.graphics.setColor(1,1,1, 0.25 - (self.z-1)/128)
  
  love.graphics.draw(texture.cloudSheet, self.quad, 0, 0)

  
  
end