Entity = Point:extend()
Entity.type = "entity"
local nextEntityID = 0
function Entity:new(x, y)
  Entity.super.new(self, x, y)
  self.id = nextEntityID
  nextEntityID = nextEntityID + 1
  self.activeStage = currentLevel.stage
end

function Entity:shouldDraw()
  return true
end


function Entity:isActive()
  return self.activeStage == currentLevel.stage or not self.activeStage
end

function Entity:delete()
  self.remove = true
end


function Entity:effectedByTimeBubble(settings, radiusOffset)
  
  settings = settings or {}
  local useMassCentre = settings.useMassCentre
  local makeInactive  = settings.makeInactive
  radiusOffset = radiusOffset or 0

  
  local pos
  
  if self.body then
    if self.body:isDestroyed() then
      return nil
    end
    
    if useMassCentre then
      pos = Vec2(self.body:getWorldCenter())
    else
      pos = Vec2(self.body:getPosition())
    end
  else
    pos = self:getPosition()
  end
  
  
  local affected = player1.timeBubble and 
  vector.getMagnitudeSqrd(player1:getPosition() - pos)  > (player1.timeBubble + radiusOffset)^2
  
  
  if self.body then
    
    if makeInactive then
      self.body:setActive(not affected)
    else
      if affected and (not self.frozen) then
        --Freeze
        self.frozenValues = {}
        self.frozenValues.velocity = {self.body:getLinearVelocity()}
        self.frozenValues.angularVelocity = self.body:getAngularVelocity()
        self.body:setType("static")
      elseif (not affected) and self.frozen then
        --Unfreeze
        self.body:setType("dynamic")
        self.body:setLinearVelocity(self.frozenValues.velocity[1], self.frozenValues.velocity[2])
        self.body:setAngularVelocity(self.frozenValues.angularVelocity)
      end
    end
    
  end
  
  
  self.frozen = affected
  
  return affected

end