CoreHolder = Interactable:extend()
CoreHolder.type = "coreHolder"
CoreHolder:implement(require("entities.components.canSave"))
CoreHolder:implement(require("entities.components.crumbles"))



function CoreHolder:new(x, y, attributes)
  Talkative.super.new(self, x, y, attributes)
  self:initSaves()
  createAttribute(self.attributes, "colour", "blue")
  createAttribute(self.attributes, "coreOffsetX", 0)
  createAttribute(self.attributes, "coreOffsetY", 0)
  
  self.saved.isHolding = true
end


function CoreHolder:delete()
  CoreHolder.super.delete(self)
  if self.droppedCore then
    self.droppedCore:delete()
  end
  
end



function CoreHolder:activate()
  if self.saved.isHolding then
    local x, y = self:getCorePosition()
    self.droppedCore = DragonCore(x, y, self.attributes.colour)
    self.saved.isHolding = false
    self.active = false
    self:crumble()
  end
end


function CoreHolder:getCorePosition()
  local x, y = self:getX(), self:getY()
  x = x + self.attributes.coreOffsetX*smallTextureScale
  y = y + self.attributes.coreOffsetY*smallTextureScale
  return x, y
end



function CoreHolder:draw()
  CoreHolder.super.draw(self)
  --Draw core here
  if self.saved.isHolding then
    local cx, cy = self:getCorePosition()
    DragonCore:draw(cx, cy, 0, self.attributes.colour)
  end
end