local LingerLight = Entity:extend()
LingerLight.type = "lingerLight"


function LingerLight:new(x, y, z, intensity, colour, fadeSpeed)
  LingerLight.super.new(self, x, y)
  self.z = z
  
  self.intensity = intensity
  self.fadeSpeed = fadeSpeed
  self.colour = colour
  
  
  
  if fadeSpeed <= 0 then
    
    cout("Warning! Lingering light will never die (fade speed of ".. fadeSpeed..")")
    
  end
  
  table.insert(drawTable, self)
end


function LingerLight:update(dt)
  
  if not self:effectedByTimeBubble() then
  
    self.intensity = self.intensity - self.fadeSpeed*dt
    
    self.remove = self.intensity <= 0
  end

end


function LingerLight:draw(dt)

  addLight(self.x, self.y, self.z, self.intensity, self.colour)

end


return LingerLight

