Bubble = Entity:extend()
Bubble.type = "bubble"
local radius = 1


function Bubble:new(x, y, vx, vy, maxHeight)
  
  Bubble.super.new(self, x, y)
  
  self.vx = vx*0.5 or 0
  self.vy = vy*0.5 or 0
  self.maxHeight = maxHeight
  self.life = 5 + love.math.random()*2
  table.insert(drawTable, self)
end



function Bubble:update(dt)
  
  
  self.life = self.life - dt
  
  if self.life <= 0 or self.y < self.maxHeight + radius then
    self:delete()
    return
  end
  
  self.vy = self.vy - dt*200
  
  
  
  self.vx = self.vx - self.vx*dt*2
  self.vy = self.vy - self.vy*dt*2
  
  
  self.x = self.x + self.vx*dt
  self.y = self.y + self.vy*dt
  
end



function Bubble:draw()

  love.graphics.setColor(1,1,1)
  
  blue.graphics.circle("line", self.x, self.y, radius)
  
end