local Projectile = require("lib.classic"):extend()
Projectile.type = "projectile"

function Projectile:new(x, y, vx, vy)
  
  
  vx = vx or 0
  vy = vy or 0
  
  self.body = love.physics.newBody(world, x, y, "dynamic")
  self.body:setLinearVelocity(vx, vy)
  self.body:setFixedRotation(true)
  self.shape = love.physics.newCircleShape(2)
  self.fixture = love.physics.newFixture(self.body, self.shape, 1)
  self.fixture:setCategory(2)
  self.fixture:setMask(2)
  
  table.insert(drawTable, self)
end


Projectile.effectedByTimeBubble = Entity.effectedByTimeBubble


function Projectile:getPosition()
  return Vec2(self.body:getPosition())
end

function Projectile:setPosition(x, y)
  self.body:setPosition(x, y)
end

function Projectile:getVelocity()
  return Vec2(self.body:getLinearVelocity())
end

function Projectile:setVelocity(x, y)
  self.body:setLinearVelocity(x, y)
end


function Projectile:draw()
  love.graphics.setColor(1, 0, 0)
  blue.graphics.circle("fill", self.body:getX(), self.body:getY(), self.shape:getRadius())
end

return Projectile