local fireComponent = {}

local lg = love.graphics


local function updateEmitter(self, dt)
  
  for i, particle in ipairs(self.particles) do
    particle:update(dt)
  end
  
  self.emissionProgress = self.emissionProgress + dt
  
  
  while self.emissionProgress >= 1 do
    self:emitParticle(0, 0)
    self.emissionProgress = self.emissionProgress - 1
  end
  
end


local function emitParticle(self, x, y)
  
  local newParticle = {}
  
  
  table.insert(self.particles, newParticle)
  
end


local function newEmitter()
  
  local emitter = {}
  
  emitter.particles = {}
  --This value causes a particle to be emitted when it reaches >=1
  emitter.emissionProgess = 0
  
  emitter.update = updateEmitter
  emitter.emitParticle = emitParticle
  
  
end


function fireComponent:makeEmitterAttributes()
  
  createAttribute(self.attributes, "fireRate", 1)
  createAttribute(self.attributes, "buffer", 100)
  createAttribute(self.attributes, "emissionDirection", 0)
  
  
  self:updateEmitter()
  
end


function fireComponent:updateEmitter()
  
  self.emitter = self.emitter or lg.newParticleSystem(texture.gradient, self.attributes.buffer)
  
  
  
end




function fireComponent:pixelCanvasDraw()
  lg.push()
  camera:applyTransformations()
  self:applyTransformations()
  

  self.emitter:draw()

  
  lg.pop()
  
end



return fireComponent