TextProp = Prop:extend()
TextProp.type = "textProp"
local lg = love.graphics

function TextProp:new(x, y, attributes)
  
  

  self.attributes = attributes or {}
  
  createAttribute(self.attributes, "text", "lorem ipsum")
  createAttribute(self.attributes, "colour", "ffffff")
  createAttribute(self.attributes, "protected", false)
  createAttribute(self.attributes, "drawPriority", 0)
  createAttribute(self.attributes, "isComment", false)
  
  self.attributes.textureName = nil
  self.attributes.animation = nil
  self.attributes.painted = nil

  TextProp.super.new(self, x, y)
  self.texture = nil
end


function TextProp:getLines()
  --Get number of lines
  local _, newLines = string.gsub(self.attributes.text, "\n", "")
  return newLines + 1
end


function TextProp:setDimentions()
  
  if self.attributes.text then
    
    local scale = smallTextureScale
    self.width = font:getWidth(self.attributes.text)   * scale * math.abs(self.attributes.scaleX or 1)
    self.height = font:getHeight(self.attributes.text) * scale * math.abs(self.attributes.scaleY or 1)*self:getLines()
  local _, newLines = string.gsu
  end
  
end




function TextProp:getTextureDimentions()
  local scale = smallTextureScale
  return font:getWidth(self.attributes.text) * scale, font:getHeight(self.attributes.text) * scale * self:getLines()
end



function TextProp:draw()

end


function TextProp:drawOverlay()
  
  if (not self.attributes.isComment) or builderMode then
  
    self:setDimentions()
    lg.push()
    camera:applyTransformations()
    
    lg.translate(self.x - self.width*0.5, self.y - self.height*0.5)
    lg.scale(smallTextureScale*self.attributes.scaleX, smallTextureScale*self.attributes.scaleY)
    local hexCode = self.attributes.colour
    if #self.attributes.colour == 6 then
      lg.setColor(
              tonumber(hexCode:sub(1, 2),16)/255,
              tonumber(hexCode:sub(3, 4),16)/255, 
              tonumber(hexCode:sub(5, 6),16)/255)
    else
      lg.setColor(1,1,1)
    end
    lg.print(self.attributes.text, 0, 0)
    
    lg.pop()
    TextProp.super.drawOverlay(self)
    
  end
end
