--My modifications to the standard graphics library
--Intended purpose is to facilitate custom transformations of the whole scene
--I was an idiot, I am now upset I was this dumb
local lg = love.graphics

blue = {}
blue.graphics = {}
local pixelWarning = false

local lightHandler = require "lighting.lightHandler"

local passes = require "rendering"


-- Transformation to apply to most items in scene

function blue.standardXTransform(x)
  x = x*camera:getFinalZoom() + (-camera.x*camera:getFinalZoom() + window.width*0.5)
  return x
end

function blue.standardYTransform(y)
  y = y*camera:getFinalZoom() + (-camera.y*camera:getFinalZoom() + window.height*0.5)
  return y
end


function blue.standardTransform(x, y)
  x = blue.standardXTransform(x)
  y = blue.standardYTransform(y)
  return x, y
end

function blue.graphics.rectangle(mode, x, y, width, height)
  x, y = blue.standardTransform(x, y)
  
  -- Note - most of these function do not take line width into account
  
  if blue.graphics.testIfOnscreen(x, y, width*2*camera:getFinalZoom(), height*2*camera:getFinalZoom()) then
    lg.rectangle(mode, x, y, width*camera:getFinalZoom(), height*camera:getFinalZoom())
  end
end


function blue.graphics.circle(mode, x, y, radius)

  x, y = blue.standardTransform(x, y)
  if blue.graphics.testIfOnscreen(x, y, radius*2*camera:getFinalZoom(), radius*2*camera:getFinalZoom()) then
    lg.circle(mode, x, y, radius*camera:getFinalZoom())
  end
end

--[[
function blue.graphics.line(x1, y1, x2, y2)
  x1, y1 = blue.standardTransform(x1, y1)
  x2, y2 = blue.standardTransform(x2, y2)
  
  lg.line(x1, y1, x2, y2)
end]]

function blue.graphics.line(...)
  lg.push()
  camera:applyTransformations()
  
  lg.line(...)
  lg.pop()
end

function blue.graphics.parallaxCircle(mode, x, y, z, radius)
  x = ((x + camera.x)*camera:getFinalZoom())/z + window.width/2
  y = ((y + camera.y)*camera:getFinalZoom())/z + window.height/2
  if blue.graphics.testIfOnscreen(x, y, radius*2*camera:getFinalZoom(), radius*2*camera:getFinalZoom()) then
    lg.circle(mode, x, y, radius*camera:getFinalZoom())
  end
end

function blue.graphics.parallaxEllipse(mode, x, y, z, radiusX, radiusY)
  x = (x + camera.x)/z + window.width/2
  y = (y + camera.y)/z + window.height/2
  if blue.graphics.testIfOnscreen(x, y, radiusX*2*camera:getFinalZoom(), radiusY*2*camera:getFinalZoom()) then
    lg.ellipse(mode, x, y, radiusX*camera:getFinalZoom(), radiusY*camera:getFinalZoom())
  end
end


function blue.graphics.parallaxDraw(drawable, x, y, z, r, sx, sy, ox, oy, kx, ky)
  
  if not drawable then
    error("Expected drawable, got nil!", 2)
  end

  if z == 0 then
    --print("WARNING - Z WAS 0. SETTING TO 1")
    z = 1
  end
  
  x = ((x + camera.x)*camera:getFinalZoom())/z + window.width/2
  y = ((y + camera.y)*camera:getFinalZoom())/z + window.height/2
  
  local textureWidth = drawable:getWidth()*sx/z
  local textureHeight = drawable:getHeight()*sy/z
  

  if kx or ky then
    print("WARNING! parallaxDraw has not been modified to take sheer into account!")
  end
  ox = ox or 0
  oy = oy or 0
  sx = sx or 1
  sy = sy or sx
  
  
  if blue.graphics.testIfOnscreen(((x + ox) + textureWidth/2*camera:getFinalZoom()), (y + oy) + textureHeight/2*camera:getFinalZoom(), textureWidth*camera:getFinalZoom(), textureHeight*camera:getFinalZoom()) then
    lg.draw(drawable, x, y, r, sx/z*camera:getFinalZoom(), sy/z*camera:getFinalZoom(), 0, 0, kx, ky)
  end
end


function blue.graphics.draw(drawable, x, y, r, sx, sy, ox, oy, kx, ky, spare) --TODO - fix onscreen test for images that rotare
  
  if not drawable then
    error("Expected drawable, got nil!", 2)
  end
  
  local isQuad = type(x) == "Userdata" and x:type() == "Quad"
  local quad
  
  if isQuad then      
    quad = x
    x = y
    y = r
    r = sx
    sx = sy
    sy = ox
    ox = oy
    oy = kx
    kx = ky
    ky = spare
  end
  
  
  x, y = blue.standardTransform(x, y)
  ox = ox or 0
  oy = oy or 0
  sx = sx or 1
  sy = sy or sx
  
  local onScreen
  
  
  
  if drawable:type() == "Mesh" then
    onScreen = true
  elseif drawable:type() ~= "SpriteBatch" and not isQuad then
    local textureWidth = drawable:getWidth()*sx
    local textureHeight = drawable:getHeight()*sy


    onScreen = (not(r == 0 or not r)) or blue.graphics.testIfOnscreen(((x + ox) + textureWidth/2*camera:getFinalZoom()), (y + oy) + textureHeight/2*camera:getFinalZoom(), textureWidth*camera:getFinalZoom(), textureHeight*camera:getFinalZoom()) 
  else
    onScreen = true
  end

  
  
  if onScreen then
    if isQuad then
      lg.draw(drawable, quad, x, y, r, sx*camera:getFinalZoom(), sy*camera:getFinalZoom(), ox, oy, kx, ky)
    else
      lg.draw(drawable, x, y, r, sx*camera:getFinalZoom(), sy*camera:getFinalZoom(), ox, oy, kx, ky)
    end
  end

end



function blue.graphics.drawCentred(drawable, x, y, r, sx, sy, ox, oy, kx, ky)
  
  x, y = blue.standardTransform(x, y)

  ox = ox or 0
  oy = oy or 0
  sx = sx or 1
  sy = sy or sx

  if drawable.main then
    drawable = drawable.main
  end
  
  local textureWidth = math.abs(drawable:getWidth()*sx)
  local textureHeight = math.abs(drawable:getHeight()*sy)
  
  local testX = (x + ox - textureWidth/2*camera:getFinalZoom()) + textureWidth/2*camera:getFinalZoom()
  local testY = (y + oy - textureHeight/2*camera:getFinalZoom()) + textureHeight/2*camera:getFinalZoom()
  local testWidth = textureWidth*camera:getFinalZoom()+ox*2
  local testHeight = textureHeight*camera:getFinalZoom()+oy*2
  
  if blue.graphics.testIfOnscreen(testX, testY, testWidth, testHeight) then
    lg.draw(drawable, x, y, r, sx*camera:getFinalZoom(), sy*camera:getFinalZoom(), ox + drawable:getWidth()/2, oy + drawable:getHeight()/2, kx, ky)
  end
  
end





function blue.graphics.polygon(mode, pointTable)
  --[[
  if pointTable[1] == pointTable[#pointTable-1] and pointTable[2] == pointTable[#pointTable] then
    
    pointTable = copyTable(pointTable)
    
    
    table.remove(pointTable, #pointTable)
    table.remove(pointTable, #pointTable)
  end]]
  

  lg.push()
  camera:applyTransformations()
  
  --Convex correction
  
  if not love.math.isConvex(pointTable) and mode == "fill" then
    
    pcall(function()
        local triangles = love.math.triangulate(pointTable)
        for i, triangle in ipairs(triangles) do
          lg.polygon(mode, triangle)
        end
        end) 
    
  else
    lg.polygon(mode, pointTable)
  end
  
  lg.pop()
end


function blue.graphics.linePolygon(pointTable)
  --This constructs a polygon out of induvidual lines, can reduce visual bugs
  
  for i = 1, #pointTable, 2 do
    local x1 = pointTable[i]
    local y1 = pointTable[i+1]
    local x2 = pointTable[i+2] or pointTable[1]
    local y2 = pointTable[i+3] or pointTable[2]
    blue.graphics.line(x1, y1, x2, y2)
    
  end
  
end

function blue.graphics.testIfOnscreen(x, y, width, height)
  
  --Important note - tests based on the centre of the rectangle, thus requires adjustment to work with functions that start in the corner
  
  --width = width --* camera:getFinalZoom()
  --height = height-- *camera:getFinalZoom()
  
  local r, g, b, a = lg.getColor()
  
  if debugMode and false then
    lg.setColor(0,0,0,1)
    lg.rectangle("line", x - width/2, y - height/2, width, height)
    lg.setColor(r, g, b, a)
  end
  
  if window.width < x - width/2 or
  0 > x + width/2 or
  window.height < y - height/2 or
  0 > y + height/2
  then
    return false
  else
    return true
  end
  
end

function blue.graphics.vectorLine(x, y, v, length)
  length = length or 1
  blue.graphics.line(x, y, x + v.x*length, y + v.y*length)
end



function blue.graphics.print(text, x, y, rot, sx, sy, ox, oy, kx, ky)
  sx = sx or 1
  x, y = blue.standardTransform(x, y)
  sy = sy or sx

  lg.print(text, x+1, y+1, rot, sx*camera:getFinalZoom(), sy*camera:getFinalZoom(), ox, oy, kx, ky)

end


function blue.graphics.printShadow(text, x, y, rot, sx, sy, ox, oy, kx, ky)

  local r, g, b, a = lg.getColor()
  a = 1
  if r == 0 and g == 0 and b == 0 then
    lg.setColor(1, 1, 1, a*0.5) 
  else
    lg.setColor(0, 0, 0) 
  end
  lg.print(text, x+1, y+1, rot, sx, sy, ox, oy, kx, ky)
  lg.setColor(r, g, b, a) 
  lg.print(text, x, y, rot, sx, sy, ox, oy, kx, ky)
  
end




function blue.graphics:wrappedDraw(drawable, x, y, r, scale)
  
  if not x then
    error("x was not given!", 2)
  elseif not y then
    error("y was not given!", 2)
  end
  
  r = r or 0
  scale =  scale or 1
  x, y = blue.standardTransform(x, y)
  
  drawable:setWrap( "repeat", "repeat" )
  
  local quad = lg.newQuad( -x, -y, window.width, window.height, drawable:getWidth()*camera:getFinalZoom()*scale, drawable:getHeight()*camera:getFinalZoom()*scale )
  lg.draw( drawable, quad, 0, 0, r, 1, 1, 0, 0)
end



function blue.graphics.drawCentredSet(set, x, y, r, sx, sy, ox, oy, kx, ky)

  blue.graphics.drawCentred(set.main, x, y, r, sx, sy, ox, oy, kx, ky)
  

  local r, g, b, a = lg.getColor()
  
  --Disables the energy shader
  lg.setShader()
  
  if set.shadow then
    lg.setColor(0, 0, 0, scene.lightHarshness)
    blue.graphics.drawCentred(set.shadow, x, y, r, sx, sy, ox, oy, kx, ky)
  end

  lg.setColor(r, g, b, a)
  
end

local z = 0

function blue.graphics.setZ(inZ)
  z = inZ
end

function blue.graphics.getZ()
  return z
end


local currentValue = z
function blue.graphics.sendZ(value)
  
  
  if currentValue ~= value then
    currentValue = value
    shader.renderPasses:send("depthValue", value)
  end
  
end



function blue.graphics.drawCentredShaded(set, x, y, r, sx, sy, ox, oy, kx, ky)
  r = r or 0
  sx = sx or 1
  sy = sy or sx
  
  blue.graphics.applyShadingVars(set, r, sx, sy)
  
  
  local oldShader = lg.getShader( )
  local isNewShader = oldShader ~= shader.renderPasses
  
  if isNewShader then
    lg.setShader(shader.renderPasses)  
  end
  blue.graphics.drawCentred(set, x, y, r, sx, sy, ox, oy, kx, ky)
  if isNewShader then
    lg.setShader(oldShader)  
  end
end


function blue.graphics.drawShaded(set, x, y, r, sx, sy, ox, oy, kx, ky)
  
  local drawable = set.main or set

  blue.graphics.applyShadingVars(set, r, sx, sy)
  
  
  local oldShader = lg.getShader( )
  local isNewShader = oldShader ~= shader.renderPasses
  
  if isNewShader then
    lg.setShader(shader.renderPasses)  
  end
  blue.graphics.draw(drawable, x, y, r, sx, sy, ox, oy, kx, ky)
  if isNewShader then
    lg.setShader(oldShader)  
  end
  
end


function blue.graphics.applyShadingVars(set, r, sx, sy)
  
  blue.graphics.sendZ(blue.graphics.getZ())
  if set and set.normalMap then
    shader.renderPasses:send("rotation", r)
    shader.renderPasses:send("flipX", sx < 0)
    shader.renderPasses:send("flipY", sy < 0)
    shader.renderPasses:send("hasNormalMap", true)
    shader.renderPasses:send("normalMap", set.normalMap)
  else
    shader.renderPasses:send("hasNormalMap", false)
  end
  
end


function blue.graphics.drawShaded(set, x, y, r, sx, sy, ox, oy, kx, ky)
  
  local drawable = set.main or set

  blue.graphics.applyShadingVars(set, r, sx, sy)
  
  
  local oldShader = lg.getShader( )
  local isNewShader = oldShader ~= shader.renderPasses
  
  if isNewShader then
    lg.setShader(shader.renderPasses)  
  end
  
  blue.graphics.draw(drawable, x, y, r, sx, sy, ox, oy, kx, ky)
  if isNewShader then
    lg.setShader(oldShader)  
  end
  
end




function blue.graphics.triangle(mode, x, y, r, radius, thickness)
  
  x, y = blue.standardTransform(x, y)
  
  if blue.graphics.testIfOnscreen(x, y, radius*2*camera:getFinalZoom(), radius*2*camera:getFinalZoom()) then
    
    thickness = thickness or 1
    local originalThickness = lg.getLineWidth()
    
    radius = radius * camera:getFinalZoom()
    local cosR = math.cos(r)
    local sinR = math.sin(r)
    
    local p1 = Vec2(-1  * radius,  0)
    local p2 = Vec2(0.5 * radius,  0.8660254038 * radius)
    local p3 = Vec2(0.5 * radius, -0.8660254038 * radius)
    
    local function rotate(v, cosR, sinR)
      local returnV = {}
      
      returnV.x = v.x * cosR  -  v.y * sinR
      returnV.y = v.y * cosR  +  v.x * sinR
      
      return returnV
    end
    
    p1 = rotate(p1, cosR, sinR)
    p2 = rotate(p2, cosR, sinR)
    p3 = rotate(p3, cosR, sinR)
    
    local points = {
      p1.x+x, p1.y+y,
      p2.x+x, p2.y+y,
      p3.x+x, p3.y+y}
    
    
    lg.setLineWidth(thickness*camera:getFinalZoom())
    
    lg.polygon(mode, points)
    
    lg.setLineWidth(originalThickness)

  end
  
end


function lg.triangle(mode, x, y, r, radius, thickness)
  
  thickness = thickness or 1
  local originalThickness = lg.getLineWidth()
  

  local cosR = math.cos(r)
  local sinR = math.sin(r)
  
  local p1 = Vec2(-1  * radius,  0)
  local p2 = Vec2(0.5 * radius,  0.8660254038 * radius)
  local p3 = Vec2(0.5 * radius, -0.8660254038 * radius)
  
  local function rotate(v, cosR, sinR)
    local returnV = {}
    
    returnV.x = v.x * cosR  -  v.y * sinR
    returnV.y = v.y * cosR  +  v.x * sinR
    
    return returnV
  end
  
  p1 = rotate(p1, cosR, sinR)
  p2 = rotate(p2, cosR, sinR)
  p3 = rotate(p3, cosR, sinR)
  
  local points = {
    p1.x+x, p1.y+y,
    p2.x+x, p2.y+y,
    p3.x+x, p3.y+y}
  
  
  lg.setLineWidth(thickness*camera:getFinalZoom())
  
  lg.polygon(mode, points)
  
  lg.setLineWidth(originalThickness)

  
end



function lg.displayKey(x, y, letter, scale)
  local _, _, _, a = love.graphics.getColor()
  scale = scale or 1

  
  lg.draw(texture.keypress, x, y, 0, smallTextureScale*scale, smallTextureScale*scale)
  
  lg.setColor(0.8,0.8,0.8,a)
  lg.print(letter, x + 9*smallTextureScale*scale, y + 3.5*smallTextureScale*scale, 0, smallTextureScale*scale, smallTextureScale*scale)

end

function lg.displayCentredKey(x, y, letter, scale)
  local _, _, _, a = love.graphics.getColor()
  
  scale = scale or 1
  
  local offsetX = - texture.keypress:getWidth()/2 * scale * smallTextureScale
  local offsetY = - texture.keypress:getHeight()/2 * scale * smallTextureScale
  
  lg.draw(texture.keypress, x + offsetX, y + offsetY, 0, smallTextureScale*scale, smallTextureScale*scale)
  
  lg.setColor(0.8,0.8,0.8, a)
  lg.print(letter, x + 9*smallTextureScale*scale + offsetX, y + 3.5*smallTextureScale*scale + offsetY, 0, smallTextureScale*scale, smallTextureScale*scale)

end


function blue.graphics.displayKey(x, y, letter, scale)
  local _, _, _, a = love.graphics.getColor()
  
  scale = scale or 1
  blue.graphics.draw(texture.keypress, x, y, 0, smallTextureScale*scale, smallTextureScale*scale)
  
  lg.setColor(0.8,0.8,0.8,a)
  blue.graphics.print(letter, x + 9*smallTextureScale*scale, y + 3.5*smallTextureScale*scale, 0, smallTextureScale*scale, smallTextureScale*scale)
  
  
end



function blue.getPolygonDimentions(pointTable)
  --Set lowest x and y values to 0, and find the offset
  local newPoints = {}
  local lowestX = pointTable[1]
  local lowestY = pointTable[2]
  local highestX = pointTable[1]
  local highestY = pointTable[2]
  
  for i, coord in ipairs(pointTable) do
    if i > 2 then
      if i%2 == 1 then
        --X
        if coord < lowestX then
          lowestX = coord
        elseif coord > highestX then
          highestX = coord
        end
      else
        --Y
        if coord < lowestY then
          lowestY = coord
        elseif coord > highestY then
          highestY = coord
        end
      end
    end
  end
  
  local width = highestX - lowestX
  local height = highestY - lowestY
  return lowestX, lowestY, width, height
end



local quad = lg.newQuad( 0, 0, 0, 0, 1, 1)

function blue.graphics.texturedPolygon(drawable, points, scale, extraX, extraY)
  
  local lowestX, lowestY, width, height = blue.getPolygonDimentions(points)
  local testX, testY = blue.standardTransform(lowestX + extraX, lowestY + extraY)
  
  local cameraZoom = camera:getFinalZoom()
  
  if blue.graphics.testIfOnscreen((testX + width*0.5*cameraZoom), testY + height*0.5*cameraZoom, width*cameraZoom, height*cameraZoom) then
  
    lg.push()
    
    x, y = blue.standardTransform(0, 0)
    
    lg.translate(x, y)
    lg.scale(camera:getFinalZoom(), camera:getFinalZoom())

    lg.stencil(
      function()
        if not love.math.isConvex(points) then
          local triangles = love.math.triangulate(points)
          for i, triangle in ipairs(triangles) do
            lg.polygon("fill", triangle)

          end
        else
          lg.polygon("fill", points)
        end
      end
    , "replace", 1)
    
    lg.setStencilTest("greater", 0)

    quad:setViewport(0, 0, width, height, scale*drawable:getWidth(), scale*drawable:getHeight())
    drawable:setWrap("repeat", "repeat")
    
    lg.draw(drawable, quad, lowestX, lowestY, 0, 1, 1)
    lg.setStencilTest()
    lg.pop()
  end
end

