local function beginContact(a, b, coll)
  
  if type(a:getUserData()) == "table" and a:getUserData().beginContactCallback then
    a:getUserData():beginContactCallback(a, b, coll)
  end
  if type(b:getUserData()) == "table" and b:getUserData().beginContactCallback then
    b:getUserData():beginContactCallback(b, a, coll)
  end
  
end

local function endContact(a, b, coll)
  
  if type(a:getUserData()) == "table" and a:getUserData().endContactCallback then
    a:getUserData():endContactCallback(a, b, coll)
  end
  if type(b:getUserData()) == "table" and b:getUserData().endContactCallback then
    b:getUserData():endContactCallback(b, a, coll)
  end
  
end


local function preSolve(a, b, coll)
  
  if type(a:getUserData()) == "table" and a:getUserData().preSolveCallback then
    a:getUserData():preSolveCallback(a, b, coll)
  end
  if type(b:getUserData()) == "table" and b:getUserData().preSolveCallback then
    b:getUserData():preSolveCallback(b, a, coll)
  end

end


local function postSolve(a, b, coll, normalimpulse, tangentimpulse)
 
  if type(a:getUserData()) == "table" and a:getUserData().postSolveCallback then
    a:getUserData():postSolveCallback(a, b, coll, normalimpulse, tangentimpulse)
  end
  if type(b:getUserData()) == "table" and b:getUserData().postSolveCallback then
    b:getUserData():postSolveCallback(b, a, coll, normalimpulse, tangentimpulse)
  end
  
end


world:setCallbacks( beginContact, endContact, preSolve, postSolve )

