local pixelCanvas = require "lib.pixelCanvas"
local lg = love.graphics
local trailPixelCanvas = pixelCanvas.create("trails")


  
function trailPixelCanvas:drawTo()
  
  local snapOffsetX, snapOffsetY, zoom = pixelCanvas:getSnapOffsets()
  
  lg.push()
  if zoom > 1 then
    
    lg.translate(1,1)
    lg.scale(1/zoom, 1/zoom)
    lg.translate(-snapOffsetX, -snapOffsetY)
  end
  
  lg.setCanvas(self.canvas)
  lg.clear(0,0,0,0)
  love.graphics.setBlendMode("alpha", "premultiplied")
  for i, object in ipairs(drawTable) do
    if object.drawTrail then
      object:drawTrail()
    end
  end

  lg.pop()
  love.graphics.setBlendMode("alpha")
end


return trailPixelCanvas