Point = require("lib.classic"):extend()
Point.type = "point"

function Point:new(x, y)
  self.x = x
  self.y = y
  
end

function Point:getPosition()
  return Vec2(self:getX(), self:getY())
end

function Point:getX()
  return self.x
end

function Point:getY()
  return self.y
end

function Point:setPosition(x, y)
  self.x = x
  self.y = y
end


function Point:distanceTo(target)
  local x, y = self:getPosition()
  local tx, ty = target:getPosition()
  return math.sqrt((x - tx)^2 + (y - ty)^2)
end

function Point:distanceToTargetSqrd(target)
  local pos = self:getPosition()
  local tpos 
  if target.getPosition then
    tpos = target:getPosition()
  else
    tpos = Vec2(target.x, target.y)
  end
  return vector.getMagnitudeSqrd(pos - tpos)
end

function Point:targetWithinDistance(target, distance)
  return self:distanceToTargetSqrd(target) <= distance^2
end