extern vec2 playerPos;
extern vec2 cameraPos;
extern float bubbleRadius;
extern float zoom;
extern float time;
extern float roundAmount;

vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords )
{
  
  //float sinOffset = sin((( screen_coords.y - cameraPos.y )/ zoom )*0.25 + time*4.0)*zoom;
  
  float x = screen_coords.y - cameraPos.y;
  
  float sinOffset = 
  (sin(x * 0.25 / zoom + time*4.0) + 
   sin(x * 0.25 * 3.14159265358979 / zoom + time*4.0)*0.5)*zoom;
  
  vec4 pixel; 
  
  if (!(
  
  pow(floor((playerPos.x - screen_coords.x + sinOffset)/roundAmount + 0.5)*roundAmount , 2.0) + 
  pow(floor((playerPos.y - screen_coords.y)/roundAmount + 0.5)*roundAmount, 2.0) 
  <= pow(bubbleRadius*zoom,2.0)
  
  
  ))
  {
    pixel = Texel(texture, vec2(texture_coords.x - sinOffset/1000.0, texture_coords.y) )*color; //This is the current pixel color
  
    number average = (pixel.r*color.r+pixel.g*color.g+pixel.b*color.b)/3.0;
  /*  pixel.r = (pixel.r + (average - pixel.r)*0.7f)*0.88f;
    pixel.g = (pixel.g + (average - pixel.g)*0.7f)*0.94f;
    pixel.b = (pixel.b + (average - pixel.b)*0.7f);*/
    
    pixel.r = pow(pixel.r, 1.3);
    pixel.g = pow(pixel.g, 1.2);
    pixel.b = pow(pixel.b, 1.1);
    
    
    
    vec2 pixelDisplacement = playerPos - screen_coords;
    
    float distanceToPlayer = length(pixelDisplacement);
    
    
    float darken = max( 1 - min( (distanceToPlayer - bubbleRadius*zoom)/800, 1 ), 0.3 );
    pixel.rgb *= darken;
    
  }
  else
  {
    pixel = Texel(texture, texture_coords)*color;
  }
  
  return pixel;
}
  