local lightingValues = {}
table.insert(drawTable, lightingValues)

local dayLength = 60*4 --Seconds

local time = 0

function lightingValues:setTime(t)
  time = t%1
  
end


function lightingValues:getTime()
  return time
end


function lightingValues:advanceTime(dt)
  self:setTime(self:getTime() + dt)
end


function lightingValues:isDay()
  return self:getTime() < 0.5
end


function lightingValues:update(dt)
  
  local clockSpeed = 1/dayLength
  self:advanceTime(dt*clockSpeed)
  
end


function lightingValues:getDirection()
  
  --Get angle from time
  
  local angle = math.pi*2 * self:getTime() - math.rad(90)
  
  local sunPosition = -vector.angleToVector(angle)
  local realmPosition = Vec2(-0.1, 0.4)
  
  return vector.normalize(realmPosition - sunPosition)
  
  --return -vector.angleToVector(angle)
end


return lightingValues




