console = {}
console.x = 10
console.y = 10
console.lines = {}
console.log = {} -- A copy of lines that keeps all inputs



function cout(...)
  args = {...}
  local final = ""
  for i, argument in ipairs(args) do
    if i == 1 then
      final = tostring(argument)
    else
      final = final.."\t"..tostring(argument)
    end
  end
  
  local newLine = {}
  newLine.value = final
  newLine.time = love.timer.getTime()
  
  table.insert(console.lines, newLine)
  table.insert(console.log, newLine)
  
  return ...
end



function console:draw()
  local textScale = 1.5
  local displayedLines = 0
  local maxLines
  
  local lineLife = 5 -- How long the line says in the console
  
  for i, line in ipairs(console.lines) do
    if love.timer.getTime() - line.time >= lineLife then
      table.remove(console.lines, i)
    end
  end
  
  for i, line in ipairs(console.lines) do
    
    local font = love.graphics.getFont()
    
    local height = self.y+font:getHeight()*textScale*(#console.lines - displayedLines-1)

    
    if height < love.graphics.getHeight() then
    
      love.graphics.setColor(0,0,0,0.5)
      love.graphics.print(line.value, self.x, height, 0, textScale, textScale)
      
      love.graphics.setColor(1,0.9,0.2)
      love.graphics.print(line.value, self.x-2, height-2, 0, textScale, textScale)
    end
    displayedLines = displayedLines + 1
    
    
  end

end


function console:dumpOutput()
  local dump = ""
  
  local logLimit = 10000
  
  if #console.log <= logLimit then
    for i, line in ipairs(console.log) do
      
      if i ~= 1 then
        dump = dump.."\n"
      end
      
      dump = dump..line.value
      
    end
  else
    
    dump = "<!> Cut off log <!>\n"
    for i = #console.log - logLimit, #console.log do
      
      local line = console.log[i]
      
      if i ~= #console.log - logLimit then
        dump = dump.."\n"
      end
      
      dump = dump..line.value
      
      
    end
  end
  if dump ~= "" then
    print(dump)
  end
end