local pauseManager = {}
local needsRecomputing = false

pauseManager.bools = {}
pauseManager.value = false

function pauseManager:isGamePaused()
  if needsRecomputing then
    self:compute()
  end
  
  return self.value
end


function pauseManager:isPaused(name)
  return self.bools[name]
end


function pauseManager:compute()
  needsRecomputing = false
  for i, bool in pairs(self.bools) do
    if bool then
      self.value = true
      return true
    end
  end
  self.value = false
  return false
end


function pauseManager:setBool(name, value)
  
  if self.bools[name] ~= value then
    needsRecomputing = true
    self.bools[name] = value
  end
  
end



